/**
 * Copyright Damiano Bolla, Cologna Veneta, Italy, All right reserved
 * Eclipse does not have any more copyright manager, so I need to edit by hand
 * GNU LESSER GENERAL PUBLIC LICENSE Version 3, 29 June 2007
 */

#ifndef STD_DEF_H
#define STD_DEF_H

/**
 * Holds STANDARD DEFINITIONS that are MACHINE INDEPENDENT
 * All definitions that are in here MUST be machine independent !!!!
 * include this into hal.h, so you just include hal.h
 */
 
#define DONE      0   // This MUST be zero, normally the test is for != DONE or simply nothing
#define FAILED    1

#define TRUE      1   // it HAS to be 1 and NOT a negative number since it is used with a single bit
#define FALSE     0

#ifndef NULL
#define NULL   ((void *)0)
#endif

// if needed you can mark some structures or union, packed
#define STRUCT_PACKED __attribute__((packed))

// the following is needed to define an empty content if nothing is defined
#ifndef STRUCT_PACKED
#define STRUCT_PACKED
#endif


#define ASCII_CR  13
#define ASCII_NL  10

#ifndef BIT0 
#define BIT0	0x01
#define BIT1	0x02
#define BIT2	0x04
#define BIT3	0x08
#define BIT4	0x10
#define BIT5	0x20
#define BIT6	0x40
#define BIT7	0x80
#endif

// The following define some time delta as the number of seconds
#define TIME_1MINUTE_S   60
#define TIME_2MINUTE_S   120
#define TIME_3MINUTE_S   180
#define TIME_4MINUTE_S   (4*60)
#define TIME_6MINUTE_S   (6*60)
#define TIME_10MINUTE_S  (10*60)
#define TIME_30MINUTE_S  (30*60)
#define TIME_1HOUR_S     (60*60)
#define TIME_4HOUR_S     (4*60*60)
#define TIME_ONEDAY_S    (24*60*60)

#define TIME_ONEDAY_M    (24*60)

// they need to be different since syntax is different for the objects !!
#define memzero_ptr(ptr)   memset(ptr,0,sizeof(*ptr))
#define memzero_obj(obj)   memset(&obj,0,sizeof(obj))
#define memzero_array(arr) memset(arr,0,sizeof(arr))


#endif 
