/**
 * Copyright Damiano Bolla, Cologna Veneta, Italy, All right reserved
 * Eclipse does not have any more copyright manager, so I need to edit by hand
 * GNU LESSER GENERAL PUBLIC LICENSE Version 3, 29 June 2007
 */

#ifndef STRINGD_H
#define STRINGD_H

/**
 * String functions that are not generally available on a platform
 * MUST be platform independent !!!
 */
#include <hal.h>
#include <std_def.h>

char *strncpyda ( void *toP, void *srcP, int dest_len );


struct string_DecimalToInt32T
   {
   // I need to return BOTH the updated strP AND the result
   char *strP;
   int32 risul;       // signed integer 32 bits
   uint8 z_count;     // how many ZEROS did the number have before reaching the first digit ?
   uint8 w_decimals;  // how many DECIMALS after the dot are there ?
   uint32 w_max_int;  // what is the max value of the integer part ?
   };

uint8 string_DecimalToInt32 ( struct string_DecimalToInt32T *paramsP );
uint8 string_DecimalToInt32dot ( struct string_DecimalToInt32T *paramsP );
char *string_int32dec_to_string(char *const toP, int to_len, int32 int32dec, uint8 decimals );

struct string_HexToUint32T
   {
   // I need to return BOTH the updated strP AND the risul
	// NOTE: that the risul is a UN signed risul
   char *strP;
   uint32 risul;
   };

// needed since I need to handle BOTH the next point where to insert
// AND the space left
struct Sappend
   {
   char *stringP;
   uint16 space_left;
   };

char *string_append(struct Sappend * const saP, char *stringP );


char *strcpyda    ( char *destP, char *dataP );
char *strncpy_escape ( char *destP, char *dataP, int dest_len );
char *string_starts_with ( char *source, char *match );
char *string_ends_with ( char *source, char *match );
char *string_strip_quotes(char *inP);
char *string_strip_leading_space ( char *source );
char *string_strip_crlf ( char *source );
char *string_escape (char *destP, int destLen, char *srcP );

char *string_int32ToDecimal(char *dest, int32 value);
char *string_uint32ToDecimal(char *dest, uint32 value);
char *string_int16ToDecimal(char *dest, int16 value);
char *string_uint16ToString(char *dest, uint16 value);
char *string_uint8a_to_hstring (char *const toP, uint32 dest_len, uint8 *srcP, uint32 src_len);

char *string_uint32ToHex(char *dest, uint32 value, uint8 append);
char *string_uint8ToHex ( char* destP, uint8 value);
int string_hex_to_bytes ( uint8 *risul_array, int array_len, char *hex_srcP );

uint8 string_DigitToNibble ( uint8 ch );
uint8 string_TwoHexDigitToUint8 ( uint8 msb, uint8 lsb );
uint8 string_nibbleToHex ( uint8 digit );

uint32 string_HexToUint32 ( char *srcP, uint32 def_value );
uint8 string_HexToUint32params ( struct string_HexToUint32T *paramsP );

char *uint8_array_to_hex_string (char *destP, uint32 dest_len, uint8 *srcP, uint32 src_len);

#endif

